SocketAppender (Apache Log4j 1.2.17 API)
Date: 2012-05-06

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.log4j.net
Class SocketAppender

    java.lang.Object
      org.apache.log4j.AppenderSkeleton
          org.apache.log4j.net.SocketAppender

All Implemented Interfaces:
  Appender, OptionHandler

    public class SocketAppender

extends AppenderSkeleton

Sends `LoggingEvent` objects to a remote a log server, usually a `SocketNode`.

The SocketAppender has the following properties:

- If sent to a `SocketNode`, remote logging is non-intrusive as far as the log event is concerned. In other words, the event will be logged with the same time stamp, `NDC`, location info as if it were logged locally by the client.

- SocketAppenders do not use a layout. They ship a serialized `LoggingEvent` object to the server side.

- Remote logging uses the TCP protocol. Consequently, if the server is reachable, then log events will eventually arrive at the server.

- If the remote server is down, the logging requests are simply dropped. However, if and when the server comes back up, then event transmission is resumed transparently. This transparent reconneciton is performed by a connector thread which periodically attempts to connect to the server.

- Logging events are automatically buffered by the native TCP implementation. This means that if the link to server is slow but still faster than the rate of (log) event production by the client, the client will not be affected by the slow network connection. However, if the network connection is slower then the rate of event production, then the client can only progress at the network rate. In particular, if the network link to the the server is down, the client will be blocked.

  On the other hand, if the network link is up, but the server is down, the client will not be blocked when making log requests but the log events will be lost due to server unavailability.

- Even if a `SocketAppender` is no longer attached to any category, it will not be garbage collected in the presence of a connector thread. A connector thread exists only if the connection to the server is down. To avoid this garbage collection problem, you should `close()` the the `SocketAppender` explicitly. See also next item.

  Long lived applications which create/destroy many `SocketAppender` instances should be aware of this garbage collection problem. Most other applications can safely ignore it.

- If the JVM hosting the `SocketAppender` exits before the `SocketAppender` is closed either explicitly or subsequent to garbage collection, then there might be untransmitted data in the pipe which might be lost. This is a common problem on Windows based systems.

  To avoid lost data, it is usually sufficient to `close()` the `SocketAppender` either explicitly or by calling the `LogManager.shutdown()` method before exiting the application.

Since:
  0.8.4
Author:
  Ceki Gülcü

Field Summary
`static int` | `DEFAULT_PORT` The default port number of remote logging server (4560).
`static String` | `ZONE` The MulticastDNS zone advertised by a SocketAppender

Fields inherited from class org.apache.log4j.AppenderSkeleton
`closed, errorHandler, headFilter, layout, name, tailFilter, threshold`

Constructor Summary
`SocketAppender()`
`SocketAppender(InetAddress address, int port)` Connects to remote server at `address` and `port`.
`SocketAppender(String host, int port)` Connects to remote server at `host` and `port`.

Method Summary
`void` | `activateOptions()` Connect to the specified RemoteHost and Port.
`void` | `append(LoggingEvent event)` Subclasses of `AppenderSkeleton` should implement this method to perform actual logging.
`void` | `cleanUp()` Drop the connection to the remote host and release the underlying connector thread if it has been created
`void` | `close()` Close this appender.
`String` | `getApplication()` Returns value of the Application option.
`boolean` | `getLocationInfo()` Returns value of the LocationInfo option.
`int` | `getPort()` Returns value of the Port option.
`int` | `getReconnectionDelay()` Returns value of the ReconnectionDelay option.
`String` | `getRemoteHost()` Returns value of the RemoteHost option.
`boolean` | `isAdvertiseViaMulticastDNS()`
`boolean` | `requiresLayout()` The SocketAppender does not use a layout.
`void` | `setAdvertiseViaMulticastDNS(boolean advertiseViaMulticastDNS)`
`void` | `setApplication(String lapp)` The App option takes a string value which should be the name of the application getting logged.
`void` | `setLocationInfo(boolean locationInfo)` The LocationInfo option takes a boolean value.
`void` | `setPort(int port)` The Port option takes a positive integer representing the port where the server is waiting for connections.
`void` | `setReconnectionDelay(int delay)` The ReconnectionDelay option takes a positive integer representing the number of milliseconds to wait between each failed connection attempt to the server.
`void` | `setRemoteHost(String host)` The RemoteHost option takes a string value which should be the host name of the server where a `SocketNode` is running.

Methods inherited from class org.apache.log4j.AppenderSkeleton
`addFilter, clearFilters, doAppend, finalize, getErrorHandler, getFilter, getFirstFilter, getLayout, getName, getThreshold, isAsSevereAsThreshold, setErrorHandler, setLayout, setName, setThreshold`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_PORT

    public static final int DEFAULT_PORT

  The default port number of remote logging server (4560).

  Since:
    1.2.15
  See Also:
    Constant Field Values

### ZONE

    public static final String ZONE

  The MulticastDNS zone advertised by a SocketAppender

  See Also:
    Constant Field Values

Constructor Detail

### SocketAppender

    public SocketAppender()

### SocketAppender

    public SocketAppender(InetAddress address,
                          int port)

  Connects to remote server at `address` and `port`.

### SocketAppender

    public SocketAppender(String host,
                          int port)

  Connects to remote server at `host` and `port`.

Method Detail

### activateOptions

    public void activateOptions()

  Connect to the specified RemoteHost and Port.

  Specified by:
    `activateOptions` in interface `OptionHandler`
  Overrides:
    `activateOptions` in class `AppenderSkeleton`

### close

    public void close()

  Close this appender.

  This will mark the appender as closed and call then `cleanUp()` method.

### cleanUp

    public void cleanUp()

  Drop the connection to the remote host and release the underlying connector thread if it has been created

### append

    public void append(LoggingEvent event)

  Description copied from class: `AppenderSkeleton`
  Subclasses of `AppenderSkeleton` should implement this method to perform actual logging. See also `AppenderSkeleton.doAppend` method.

  Specified by:
    `append` in class `AppenderSkeleton`

### setAdvertiseViaMulticastDNS

    public void setAdvertiseViaMulticastDNS(boolean advertiseViaMulticastDNS)

### isAdvertiseViaMulticastDNS

    public boolean isAdvertiseViaMulticastDNS()

### requiresLayout

    public boolean requiresLayout()

  The SocketAppender does not use a layout. Hence, this method returns `false`.

### setRemoteHost

    public void setRemoteHost(String host)

  The RemoteHost option takes a string value which should be the host name of the server where a `SocketNode` is running.

### getRemoteHost

    public String getRemoteHost()

  Returns value of the RemoteHost option.

### setPort

    public void setPort(int port)

  The Port option takes a positive integer representing the port where the server is waiting for connections.

### getPort

    public int getPort()

  Returns value of the Port option.

### setLocationInfo

    public void setLocationInfo(boolean locationInfo)

  The LocationInfo option takes a boolean value. If true, the information sent to the remote host will include location information. By default no location information is sent to the server.

### getLocationInfo

    public boolean getLocationInfo()

  Returns value of the LocationInfo option.

### setApplication

    public void setApplication(String lapp)

  The App option takes a string value which should be the name of the application getting logged. If property was already set (via system property), don't set here.

  Since:
    1.2.15

### getApplication

    public String getApplication()

  Returns value of the Application option.

  Since:
    1.2.15

### setReconnectionDelay

    public void setReconnectionDelay(int delay)

  The ReconnectionDelay option takes a positive integer representing the number of milliseconds to wait between each failed connection attempt to the server. The default value of this option is 30000 which corresponds to 30 seconds.

  Setting this option to zero turns off reconnection capability.

### getReconnectionDelay

    public int getReconnectionDelay()

  Returns value of the ReconnectionDelay option.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2012 Apache Software Foundation. All Rights Reserved.